@echo off

REM  This file is part of EST (Efficient Symbolic Tools).
REM  Copyright (C) 2003, 2010
REM  UM-FERI, Smetanova ulica 17, SI-2000 Maribor, Slovenia
REM
REM  EST is free software; you can redistribute it and/or modify
REM  it under the terms of the GNU General Public License as
REM  published by the Free Software Foundation; either version 2
REM  of the License, or (at your option) any later version.
REM
REM  EST is distributed in the hope that it will be useful,
REM  but WITHOUT ANY WARRANTY; without even the implied warranty of
REM  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
REM  GNU General Public License for more details.
REM
REM  You should have received a copy of the GNU General Public
REM  License along with this program; if not, write to the Free
REM  Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
REM  Boston, MA 02110-1301 USA.]

SET EDITION=est-2ed
FOR /F "USEBACKQ" %%T IN (`TYPE source\VERSION`) DO SET VVERSION=%%T
SET VERSION=%VVERSION:.=-%
SET OS=Win
SET BBINDIR="%cd%\bin"
SET BINDIR=%BBINDIR:\=/%

SET NAME=EST, 2nd Edition
SET RELEASE=Release: %VVERSION%  (%DATE%)

rm %EDITION%-%VERSION%-%OS%-mish.zip
rm %EDITION%-%VERSION%-%OS%-mish.exe
rm %EDITION%-%VERSION%-%OS%.zip
rm -fr bin

echo Creating %EDITION%-%VERSION%-%OS%-mish.exe ...

cd source
make mish "BINDIR=%BINDIR%"
make clean "BINDIR=%BINDIR%"
cp COPYING ../bin
cp est2ed.tcl ../bin
cp pkgIndex.tcl ../bin
cp ../../myinterface/mi.tcl ../bin
cp ../../myinterface/miDialog.tcl ../bin
cp bdd/bddDialog.tcl ../bin
cp pa/paDialog.tcl ../bin
cp versis/versisDialog.tcl ../bin
cp mc/mcDialog.tcl ../bin
cp strucval/strucvalDialog.tcl ../bin
cp ccs/ccsDialog.tcl ../bin
cp ../etc/est-bw.ico ../bin
make milocal "BINDIR=%BINDIR%"
cd ..
..\mingw\info-zip\zip -o -q -r %EDITION%-%VERSION%-%OS%-mish.zip bin\*
..\mingw\info-zip\zip -o -q %EDITION%-%VERSION%-%OS%-mish.zip etc\* -x .svn
..\mingw\info-zip\zip -o -q %EDITION%-%VERSION%-%OS%-mish.zip data\* -x .svn
..\mingw\info-zip\zip -o -q %EDITION%-%VERSION%-%OS%-mish.zip data\*\* -x .svn
..\mingw\FreeExtractor\MakeSFX /zip="%EDITION%-%VERSION%-%OS%-mish.zip" /sfx="%EDITION%-%VERSION%-%OS%-mish.exe" /title="Efficient Symbolic Tools package" /website="http://lms.uni-mb.si/EST/" /intro="%RELEASE%\n\nThis is binary distribution of %NAME%.\nThis is free software. See GNU GPL (version 2).\n\nYou need ActiveTcl installed on your computer.\nTo start the program click est.tcl in folder bin.\n\nFreeExtractor Wizard will make the following tasks:\n1. Files will be extracted into the target folder.\n2. A shortcut will be created on your desktop.\n\nNOTE: No registry entry will be changed and no file will be\n            created outside the target folder. You can uninstall\n            this software by simply deleting the target folder.\n\nRobert Meolic (meolic@uni-mb.si)" /defaultpath="C:\Program Files\%EDITION%" /shortcut="$desktop$\EST.LNK|$targetdir$\bin\est.tcl" /icon="etc\est-bw.ico" /overwrite

rm %EDITION%-%VERSION%-%OS%-mish.zip
rm -fr bin

echo Creating %EDITION%-%VERSION%-%OS%.zip ...

cd source
make lib "BINDIR=%BINDIR%"
make clean "BINDIR=%BINDIR%"
cp est.h ../bin
cd ../..
.\mingw\info-zip\zip -o -q -r %EDITION%\%EDITION%-%VERSION%-%OS%.zip %EDITION%\bin\*
cd %EDITION%\source
make staticlib "BINDIR=%BINDIR%"
make clean "BINDIR=%BINDIR%"
cd ../..
.\mingw\info-zip\zip -o -q -r %EDITION%\%EDITION%-%VERSION%-%OS%.zip %EDITION%\bin\libest2.a
cd %EDITION%
rm -fr bin

cd ..
.\mingw\info-zip\zip -o -q %EDITION%\%EDITION%-%VERSION%-%OS%.zip %EDITION%\projects\* -x .svn
.\mingw\info-zip\zip -o -q %EDITION%\%EDITION%-%VERSION%-%OS%.zip %EDITION%\projects\*\* -x .svn
cd %EDITION%

echo *******************
echo PACKAGES COMPLETED!
echo *******************
