#  Authors     [Robert Meolic (meolic@uni-mb.si)]
#  Revision    [$Revision: 40 $]
#  Date        [$Date: 2010-10-25 23:40:59 +0200 (Mon, 25 Oct 2010) $]
#
#  Copyright   [This file is part of EST (Efficient Symbolic Tools).
#               Copyright (C) 2003, 2010
#               UM-FERI, Smetanova ulica 17, SI-2000 Maribor, Slovenia
#
#               EST is free software; you can redistribute it and/or modify
#               it under the terms of the GNU General Public License as
#               published by the Free Software Foundation; either version 2
#               of the License, or (at your option) any later version.
#
#               EST is distributed in the hope that it will be useful,
#               but WITHOUT ANY WARRANTY; without even the implied warranty of
#               MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
#               GNU General Public License for more details.
#
#               You should have received a copy of the GNU General Public
#               License along with this program; if not, write to the Free
#               Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
#               Boston, MA 02110-1301 USA.]

global MENUBG
global MENUFG
global MENUFONT
global MENUITEMS
global MENUBUTTONITEMS

foreach item  [list \
       .menuFrame.ccs \
         .menuFrame.ccs.menu \
]  { lappend MENUITEMS $item}

lappend MENUBUTTONITEMS .menuFrame.ccs

menubutton .menuFrame.ccs -activebackground #ffffc0 -activeforeground #000040 -background $MENUBG -disabledforeground $MENUFG -font MENUFONT -foreground $MENUFG -menu .menuFrame.ccs.menu -pady 1 -text "CCS"
pack .menuFrame.ccs -side left
menu .menuFrame.ccs.menu -activebackground #ffffc0 -activeborderwidth 1 -activeforeground #000040 -background $MENUBG -borderwidth 4 -font MENUFONT -foreground $MENUFG -relief groove -tearoff false
.menuFrame.ccs.menu add command  -command menu_ccs_read -label "ccs_read"
.menuFrame.ccs.menu add command  -command menu_ccs_convert_verilog -label "ccs_convert_verilog"
.menuFrame.ccs.menu add separator 
.menuFrame.ccs.menu add command  -command ccs_about -label "ccs_about"

proc ccs_about {  } {
        global BINDIR

        outline ""
        outline "\#\#\# "
        out "\# "
        ccs_aboutPkg

        set OK ""
        if {[file isfile "/usr/lib/est2ed/ccs.about"]} {
          set OK "OK"
          set f [open "/usr/lib/est2ed/ccs.about" r]
        } else {
          if {[file isfile "$BINDIR/ccs.about"]} {
            set OK "OK"
            set f [open "$BINDIR/ccs.about" r]
          }
        }

        if { $OK == "OK"} {
          while {[gets $f line] >= 0} {
            out "\# "
	    outline $line
	  }	
          outline "\#\#\# "
	  close $f
        }
}

proc menu_ccs_read {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
	global CMD
	global CMDEND
        global PARAM
	
	set NAME "ccs_read"
	set SYNOPSIS "Read CCS file."
	set SYNTAX "fname%s"
	set EXAMPLE "ccs_read philo/philo.ccs"
	set EXPLANATION "Read file ./philo/philo.ccs"
        set BROWSE [list \
          {file "Select file with CCS model" {{{CCS model} {.ccs}} {{All files} {*.*}}}} \
        ]
	
	set CMD $NAME
	set CMDEND ""
	set PARAM ""
	
	commonDialog
	
}

proc menu_ccs_convert_verilog {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
	global CMD
	global CMDEND
        global PARAM
	
	set NAME "ccs_convert_verilog"
	set SYNOPSIS "Read Verilog netlist and represent it with CCS."
	set SYNTAX "fname%s"
	set EXAMPLE "ccs_convert_verilog iscas85/c17.v"
	set EXPLANATION "Convert Verilog netlist from file ./iscas85/c17.v"
        set BROWSE [list \
          {file "Select file with Verilog netlist" {{{CCS model} {.v}} {{All files} {*.*}}}} \
          {nonempty "Output file" 60} \
        ]
	
	set CMD $NAME
	set CMDEND ""
	set PARAM ""
	
	commonDialog
	
}
