#  Authors     [Robert Meolic (meolic@uni-mb.si)]
#  Revision    [$Revision: 40 $]
#  Date        [$Date: 2010-10-25 23:40:59 +0200 (Mon, 25 Oct 2010) $]
#
#  Copyright   [This file is part of EST (Efficient Symbolic Tools).
#               Copyright (C) 2003, 2010
#               UM-FERI, Smetanova ulica 17, SI-2000 Maribor, Slovenia
#
#               EST is free software; you can redistribute it and/or modify
#               it under the terms of the GNU General Public License as
#               published by the Free Software Foundation; either version 2
#               of the License, or (at your option) any later version.
#
#               EST is distributed in the hope that it will be useful,
#               but WITHOUT ANY WARRANTY; without even the implied warranty of
#               MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
#               GNU General Public License for more details.
#
#               You should have received a copy of the GNU General Public
#               License along with this program; if not, write to the Free
#               Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
#               Boston, MA 02110-1301 USA.]

global MENUBG
global MENUFG
global MENUFONT
global MENUITEMS
global MENUBUTTONITEMS

foreach item  [list \
       .menuFrame.pa \
         .menuFrame.pa.menu \
           .menuFrame.pa.processes \
           .menuFrame.pa.compositions \
]  { lappend MENUITEMS $item}

lappend MENUBUTTONITEMS .menuFrame.pa

menubutton .menuFrame.pa -activebackground #ffffc0 -activeforeground #000040 -background $MENUBG -disabledforeground $MENUFG -font MENUFONT -foreground $MENUFG -menu .menuFrame.pa.menu -pady 1 -text "Process algebra"
pack .menuFrame.pa -side left
menu .menuFrame.pa.menu -activebackground #ffffc0 -activeborderwidth 1 -activeforeground #000040 -background $MENUBG -borderwidth 4 -font MENUFONT -foreground $MENUFG -relief groove -tearoff false
.menuFrame.pa.menu add command  -command menu_pa_readProcess -label "pa_read_process"
.menuFrame.pa.menu add separator 
.menuFrame.pa.menu add command  -command menu_pa_writeSort -label "pa_write_sort"
.menuFrame.pa.menu add command  -command menu_pa_writeProcessCCS -label "pa_write_process_ccs"
.menuFrame.pa.menu add separator 
.menuFrame.pa.menu add command  -command menu_pa_encodeProcess -label "pa_encode_process"
.menuFrame.pa.menu add separator 
.menuFrame.pa.menu add command  -command menu_pa_decodeProcess -label "pa_decode_process"
.menuFrame.pa.menu add command  -command menu_pa_decodeProcVisible -label "pa_decode_proc_visible"
.menuFrame.pa.menu add command  -command menu_pa_decodeComposition -label "pa_decode_composition"
.menuFrame.pa.menu add command  -command menu_pa_decodeCompVisible -label "pa_decode_comp_visible"
.menuFrame.pa.menu add separator 
.menuFrame.pa.menu add command  -command menu_pa_decodeInitialState -label "pa_decode_initial_state"
.menuFrame.pa.menu add command  -command menu_pa_decodeComposedState -label "pa_decode_composed_state"
.menuFrame.pa.menu add separator 
.menuFrame.pa.menu add command  -command menu_pa_copyProcess -label "pa_copy_process"
.menuFrame.pa.menu add command  -command menu_pa_process2composition -label "pa_process2composition"
.menuFrame.pa.menu add command  -command menu_pa_composition2process -label "pa_composition2process"
.menuFrame.pa.menu add separator 
.menuFrame.pa.menu add cascade  -label "Processes..." -menu .menuFrame.pa.processes
.menuFrame.pa.menu add cascade  -label "Compositions..." -menu .menuFrame.pa.compositions
.menuFrame.pa.menu add separator 
.menuFrame.pa.menu add command  -command pa_about -label "pa_about"

menu .menuFrame.pa.processes -activebackground #ffffc0 -activeborderwidth 1 -activeforeground #000040 -background $MENUBG -borderwidth 4 -font MENUFONT -foreground $MENUFG -relief groove -tearoff false
.menuFrame.pa.processes add command  -command menu_pa_stateNumber -label "pa_state_number"
.menuFrame.pa.processes add command  -command menu_pa_transitionNumber -label "pa_transition_number"
.menuFrame.pa.processes add command  -command menu_pa_transitionVisible -label "pa_transition_visible"

menu .menuFrame.pa.compositions -activebackground #ffffc0 -activeborderwidth 1 -activeforeground #000040 -background $MENUBG -borderwidth 4 -font MENUFONT -foreground $MENUFG -relief groove -tearoff false
.menuFrame.pa.compositions add command  -command menu_pa_compStateNumber -label "pa_comp_state_number"
.menuFrame.pa.compositions add command  -command menu_pa_compTransitionNumber -label "pa_comp_transition_number"
.menuFrame.pa.compositions add command  -command menu_pa_compTransitionVisible -label "pa_comp_transition_visible"

proc pa_about {  } {
        global BINDIR

        outline ""
        outline "\#\#\# "
        out "\# "
        pa_aboutPkg

        set OK ""
        if {[file isfile "/usr/lib/est2ed/pa.about"]} {
          set OK "OK"
          set f [open "/usr/lib/est2ed/pa.about" r]
        } else {
          if {[file isfile "$BINDIR/pa.about"]} {
            set OK "OK"
            set f [open "$BINDIR/pa.about" r]
          }
        }

        if { $OK == "OK"} {
          while {[gets $f line] >= 0} {
            out "\# "
	    outline $line
	  }	
          outline "\#\#\# "
	  close $f
        }
}

proc menu_pa_readProcess {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
	global CMD
	global CMDEND
	global PARAM
	
	set NAME "pa_read_process"
	set SYNOPSIS "Read file."
	set SYNTAX "fname%s"
	set EXAMPLE "pa_read_process data/system.dat"
	set EXPLANATION "Read file ./data/system.dat"
        set BROWSE [list \
	  {file "Select file" {{{Internal format} {.dat}}}} \
        ]
	
	set CMD $NAME
	set CMDEND ""
	set PARAM ""
	
	commonDialog
	
}

proc menu_pa_copyProcess {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
	global CMD
	global CMDEND
	global PARAM
	
	set NAME "pa_copy_process"
	set SYNOPSIS "Copy process."
	set SYNTAX "pname%s pname%s sname%s alist%s alist%s"
	set EXAMPLE "pa_copy_process p1 p1copy NULL \"a b\" \"A B\""
	set EXPLANATION "Copy process and rename some actions"
        set BROWSE [list \
          {name "Select original process" proc} \
          {nonempty "New process" 30} \
          {optional "Sort of new process (optional, NULL = use original)" 30} \
          {optional "List of original action names (optional)" 30} \
          {optional "List of new action names (optional)" 30} \
        ]
	
	set CMD $NAME
	set CMDEND ""
	set PARAM ""
	
	commonDialog
	
}

proc menu_pa_process2composition {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
	global CMD
	global CMDEND
	global PARAM
	
	set NAME "pa_process2composition"
	set SYNOPSIS "Create composition from a process"
	set SYNTAX "pname%s"
	set EXAMPLE "pa_process2composition p1"
	set EXPLANATION "Create a compositon p1 from the process p1"
        set BROWSE [list \
          {name "Select process" proc} \
        ]
	
	set CMD $NAME
	set CMDEND ""
	set PARAM ""
	
	commonDialog
	
}

proc menu_pa_composition2process {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
	global CMD
	global CMDEND
	global PARAM
	
	set NAME "pa_composition2process"
	set SYNOPSIS "Create a process from composition"
	set SYNTAX "pname%s"
	set EXAMPLE "pa_composition2process p1"
	set EXPLANATION "Create a process p1 from the composition p1"
        set BROWSE [list \
          {name "Select composition" comp} \
        ]
	
	set CMD $NAME
	set CMDEND ""
	set PARAM ""
	
	commonDialog
	
}

proc menu_pa_writeSort {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
	global CMD
	global CMDEND
	global PARAM
	
	set NAME "pa_write_sort"
	set SYNOPSIS "Write sort."
	set SYNTAX "sname%s"
	set EXAMPLE "pa_write_sort mysort"
	set EXPLANATION "Write out sort mysort"
        set BROWSE [list \
          {name "Select sort" sort} \
        ]
	
	set CMD $NAME
	set CMDEND ""
	set PARAM ""
	
	commonDialog
	
}

proc menu_pa_writeProcessCCS {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
	global CMD
	global CMDEND
	global PARAM
	
	set NAME "pa_write_process_ccs"
	set SYNOPSIS "Report process in CCS format."
	set SYNTAX "pname%s"
	set EXAMPLE "pa_write_process_ccs p1"
	set EXPLANATION "Report process p1"
        set BROWSE [list \
          {name "Select process" proc} \
        ]
	
	set CMD $NAME
	set CMDEND ""
	set PARAM ""
	
	commonDialog
	
}

proc menu_pa_encodeProcess {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
	global CMD
	global CMDEND
	global PARAM
	
	set NAME "pa_encode_process"
	set SYNOPSIS "Encode processes."
	set SYNTAX "plist%s"
	set EXAMPLE "pa_encode_process \"p1 p2\""
	set EXPLANATION "Encode processes p1 and p2"
        set BROWSE [list \
          {list "Select list of processes" proc} \
        ]
	
	set CMD $NAME
	set CMDEND ""
	set PARAM ""
	
	commonDialog
	
}

proc menu_pa_decodeProcess {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
	global CMD
	global CMDEND
	global PARAM
	
	set NAME "pa_decode_process"
	set SYNOPSIS "Decode process."
	set SYNTAX "pname%s"
	set EXAMPLE "pa_decode_process p1"
	set EXPLANATION "Decode process p1"
        set BROWSE [list \
          {name "Select process" proc} \
        ]
	
	set CMD $NAME
	set CMDEND ""
	set PARAM ""
	
	commonDialog
	
}

proc menu_pa_decodeProcVisible {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
	global CMD
	global CMDEND
	global PARAM
	
	set NAME "pa_decode_proc_visible"
	set SYNOPSIS "Decode visible part of process."
	set SYNTAX "pname%s"
	set EXAMPLE "pa_decode_proc_visible p1"
	set EXPLANATION "Decode visible part of process p1"
        set BROWSE [list \
          {name "Select process" proc} \
        ]
	
	set CMD $NAME
	set CMDEND ""
	set PARAM ""
	
	commonDialog
	
}

proc menu_pa_decodeComposition {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
	global CMD
	global CMDEND
	global PARAM
	
	set NAME "pa_decode_composition"
	set SYNOPSIS "Decode composition."
	set SYNTAX "pname%s"
	set EXAMPLE "pa_decode_composition c1"
	set EXPLANATION "Decode composition c1"
        set BROWSE [list \
          {name "Select composition" comp} \
        ]
	
	set CMD $NAME
	set CMDEND ""
	set PARAM ""
	
	commonDialog
	
}

proc menu_pa_decodeCompVisible {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
	global CMD
	global CMDEND
	global PARAM
	
	set NAME "pa_decode_comp_visible"
	set SYNOPSIS "Decode visible part of composition."
	set SYNTAX "pname%s"
	set EXAMPLE "pa_decode_comp_visible c1"
	set EXPLANATION "Decode visible part of composition c1"
        set BROWSE [list \
          {name "Select composition" comp} \
        ]
	
	set CMD $NAME
	set CMDEND ""
	set PARAM ""
	
	commonDialog
	
}

proc menu_pa_decodeInitialState {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
	global CMD
	global CMDEND
	global PARAM
	
	set NAME "pa_decode_initial_state"
	set SYNOPSIS "Decode initial state."
	set SYNTAX "type%d name%s"
	set EXAMPLE "pa_decode_initial_state 0 p"
	set EXPLANATION "Decode initial state in process p"
        set BROWSE [list \
          {name "Select process/composition" proccomp} \
        ]
	set CMD $NAME
	set CMDEND ""
	set PARAM ""
	
	commonDialog
	
}

proc menu_pa_decodeComposedState {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
	global CMD
	global CMDEND
	global PARAM
	
	set NAME "pa_decode_composed_state"
	set SYNOPSIS "Decode composed state in a process."
	set SYNTAX "pname%s sname%s"
	set EXAMPLE "pa_decode_composed_state p s0"
	set EXPLANATION "Decode composed state s0 in process p"
        set BROWSE [list \
          {name "Select process" proc} \
          {nonempty "State" 30} \
        ]
	
	set CMD $NAME
	set CMDEND ""
	set PARAM ""
	
	commonDialog
	
}

proc menu_pa_stateNumber {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
	global CMD
	global CMDEND
	global PARAM
	
	set NAME "pa_state_number"
	set SYNOPSIS "Count states in a process."
	set SYNTAX "pname%s"
	set EXAMPLE "outline \[pa_state_number p1\]"
	set EXPLANATION "Count states in process p1"
        set BROWSE [list \
          {name "Select process" proc} \
        ]
	
	set CMD "outline \[$NAME"
	set CMDEND "\]"
	set PARAM ""
	
	commonDialog
	
}

proc menu_pa_transitionNumber {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
	global CMD
	global CMDEND
	global PARAM
	
	set NAME "pa_transition_number"
	set SYNOPSIS "Count transitions in a process."
	set SYNTAX "pname%s"
	set EXAMPLE "outline \[pa_transition_number p1\]"
	set EXPLANATION "Count transitions in process p1"
        set BROWSE [list \
          {name "Select process" proc} \
        ]
	
	set CMD "outline \[$NAME"
	set CMDEND "\]"
	set PARAM ""

	commonDialog
	
}

proc menu_pa_transitionVisible {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
	global CMD
	global CMDEND
	global PARAM
	
	set NAME "pa_transition_visible"
	set SYNOPSIS "Count visible transitions in a process."
	set SYNTAX "pname%s"
	set EXAMPLE "outline \[pa_transition_visible p1\]"
	set EXPLANATION "Count visible transitions in process p1"
        set BROWSE [list \
          {name "Select process" proc} \
        ]
	
	set CMD "outline \[$NAME"
	set CMDEND "\]"
	set PARAM ""

	commonDialog
	
}

proc menu_pa_compStateNumber {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
	global CMD
	global CMDEND
	global PARAM
	
	set NAME "pa_comp_state_number"
	set SYNOPSIS "Count states in a composition."
	set SYNTAX "pname%s"
	set EXAMPLE "outline \[pa_comp_state_number c1\]"
	set EXPLANATION "Count states in composition c1"
        set BROWSE [list \
          {name "Select composition" comp} \
        ]
	
	set CMD "outline \[$NAME"
	set CMDEND "\]"
	set PARAM ""

	commonDialog
	
}

proc menu_pa_compTransitionNumber {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
	global CMD
	global CMDEND
	global PARAM
	
	set NAME "pa_comp_transition_number"
	set SYNOPSIS "Count transitions in a composition."
	set SYNTAX "pname%s"
	set EXAMPLE "outline \[pa_comp_transition_number c1\]"
	set EXPLANATION "Count transitions in composition c1"
        set BROWSE [list \
          {name "Select composition" comp} \
        ]
	
	set CMD "outline \[$NAME"
	set CMDEND "\]"
	set PARAM ""

	commonDialog
	
}

proc menu_pa_compTransitionVisible {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
	global CMD
	global CMDEND
	global PARAM
	
	set NAME "pa_comp_transition_visible"
	set SYNOPSIS "Count visible transitions in a composition."
	set SYNTAX "pname%s"
	set EXAMPLE "outline \[pa_comp_transition_visible c1\]"
	set EXPLANATION "Count visible transitions in composition c1"
        set BROWSE [list \
          {name "Select composition" comp} \
        ]
	
	set CMD "outline \[$NAME"
	set CMDEND "\]"
	set PARAM ""

	commonDialog
	
}
