#  Authors     [Robert Meolic (meolic@uni-mb.si)]
#  Revision    [$Revision: 40 $]
#  Date        [$Date: 2010-10-25 23:40:59 +0200 (Mon, 25 Oct 2010) $]
#
#  Copyright   [This file is part of EST (Efficient Symbolic Tools).
#               Copyright (C) 2003, 2010
#               UM-FERI, Smetanova ulica 17, SI-2000 Maribor, Slovenia
#
#               EST is free software; you can redistribute it and/or modify
#               it under the terms of the GNU General Public License as
#               published by the Free Software Foundation; either version 2
#               of the License, or (at your option) any later version.
#
#               EST is distributed in the hope that it will be useful,
#               but WITHOUT ANY WARRANTY; without even the implied warranty of
#               MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
#               GNU General Public License for more details.
#
#               You should have received a copy of the GNU General Public
#               License along with this program; if not, write to the Free
#               Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
#               Boston, MA 02110-1301 USA.]

global MENUBG
global MENUFG
global MENUFONT
global MENUITEMS
global MENUBUTTONITEMS

foreach item  [list \
       .menuFrame.strucval \
         .menuFrame.strucval.menu \
]  { lappend MENUITEMS $item}

lappend MENUBUTTONITEMS .menuFrame.strucval

menubutton .menuFrame.strucval -activebackground #ffffc0 -activeforeground #000040 -background $MENUBG -disabledforeground $MENUFG -font MENUFONT -foreground $MENUFG -menu .menuFrame.strucval.menu -pady 1 -text "Strucval"
pack .menuFrame.strucval -side left
menu .menuFrame.strucval.menu -activebackground #ffffc0 -activeborderwidth 1 -activeforeground #000040 -background $MENUBG -borderwidth 4 -font MENUFONT -foreground $MENUFG -relief groove -tearoff false
.menuFrame.strucval.menu add command  -command menu_strucval_syncProdukt -label "strucval_sync_product"
.menuFrame.strucval.menu add separator 
.menuFrame.strucval.menu add command  -command strucval_about -label "strucval_about"

proc strucval_about {  } {
        global BINDIR

        outline ""
        outline "\#\#\# "
        out "\# "
        strucval_aboutPkg

        set OK ""
        if {[file isfile "/usr/lib/est2ed/strucval.about"]} {
          set OK "OK"
          set f [open "/usr/lib/est2ed/strucval.about" r]
        } else {
          if {[file isfile "$BINDIR/strucval.about"]} {
            set OK "OK"
            set f [open "$BINDIR/strucval.about" r]
          }
        }

        if { $OK == "OK"} {
          while {[gets $f line] >= 0} {
            out "\# "
	    outline $line
	  }	
          outline "\#\#\# "
	  close $f
        }
}

proc menu_strucval_syncProdukt {  } {
	global NAME
	global SYNOPSIS
	global SYNTAX
	global EXAMPLE
	global EXPLANATION
        global BROWSE
	global CMD
	global CMDEND
        global PARAM
        global diagnostic
        global automaton
        global explain
        global minimize
        global tracepath
	
	set NAME "strucval_sync_product"
	set SYNOPSIS "Synchronous product between a process and a WCA"
	set SYNTAX "pname%s pname%s pname%s alist%s"
	set EXAMPLE "strucval_sync_product PRODUCT P A \"x y e\""
	set EXPLANATION "Create synchronous product between process P and WCA A"
        set BROWSE [list \
          {nonempty "Product name" 30} \
          {name "Select process" proc} \
          {name "Select WCA" proc} \
          {required "List of internal action names" 30} \
        ]

	set CMD $NAME
	set CMDEND ""
	set PARAM ""

       	commonDialog
}
